=== debian/changelog ===
minetest (5.2.0+repack-1) unstable; urgency=medium

  [ Michael Gilbert ]
  * Remove myself from the uploaders.

  [ Markus Koschany ]
  * New upstream version 5.2.0+repack.
  * Switch to debhelper-compat = 13.
  * Build-depend on libspatialindex-dev and build with ENABLE_SPATIAL=ON,
    to speed up AreaStores.

 -- Markus Koschany <apo@debian.org>  Sun, 19 Apr 2020 22:30:13 +0200

minetest (5.1.1+repack-2) unstable; urgency=medium

  * Explicitly set CMAKE_BUILD_TYPE to Release to avoid unexpected errors.
    Reported upstream as https://github.com/minetest/minetest/issues/9543
    Thanks to Krock for the report.

 -- Markus Koschany <apo@debian.org>  Tue, 31 Mar 2020 21:37:37 +0200
