=== debian/changelog ===
minetest (5.3.0+repack-2.1+deb11u1) bullseye-security; urgency=high

  * Fix CVE-2022-24300 and CVE-2022-24301:
    Several vulnerabilities have been discovered in Minetest. These issues may
    allow attackers to manipulate game mods by adding or modifying meta fields
    of the same item stack and grant them an unfair advantage over other
    players. These flaws could also be abused for a denial of service attack.
    (Closes: #1004223)

 -- Markus Koschany <apo@debian.org>  Sun, 13 Feb 2022 20:25:34 +0100

minetest (5.3.0+repack-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add upstream fix for errors caused by missing param2
    in falling.lua, thanks to Craig Small. (Closes: #990923)

 -- Adrian Bunk <bunk@debian.org>  Thu, 15 Jul 2021 18:55:57 +0300

minetest (5.3.0+repack-2) unstable; urgency=medium

  * Team upload.
  * Fixed 'minetest-data: debian/copyright needs updating'. Reflect upstream
    license changes in copyright documentation. (Closes: #979012)

 -- Bruno Kleinert <fuddl@debian.org>  Sun, 31 Jan 2021 14:41:26 +0100

minetest (5.3.0+repack-1) unstable; urgency=medium

  * New upstream version 5.3.0+repack.

 -- Markus Koschany <apo@debian.org>  Sat, 11 Jul 2020 23:10:38 +0200
